# Tipsy Turtle

Artists welcome! This is a turtle graphics program that can load and save image files in the usual formats. It can make banners and such, or draw decorative patterns on top of existing pictures. While I made it for fun, it's capable enough to generate the official cover art and logo for itself.

Tipsy Turtle uses familiar turtle graphics commands, though some of them work in unusual ways. However the programming language is a Forth dialect.

## Requirements

Tipsy Turtle is available as native executables for 32-bit and 64-bit Linux, and also as source code. On Linux, it requires the Gtk3 library to run.

This program is written in the Nim programming language, with the NiGui library. You need a Nim compiler to build it, which in turn requires a C compiler. A copy of NiGui 0.2.7 (as of 30 May 2023) is included with the source code.

It should be possible to make a native Windows build. You're on your own there.

## How to use

In a turtle graphics system, you draw not with the mouse, but by directing a virtual "turtle", that traces its path while moving, with an equally virtual pen. Directions are usually of the form: "walk forward this many steps, turn right this many degrees, repeat n times". But since our turtle is kinda tipsy, it only understands directions given backwards:

        50 forward
        50 forward 90 right
        [ 100 fd 90 rt ] 3 times
        { [ 100 fd 90 rt ] 4 times 36 rt } 10 times

You can enter the above one by one on the command line, or all at once in the Forth console.

Speaking of which: Tipsy Turtle understands a Forth dialect named Ripen. More details about the language proper are available on its own website. For a few examples, load the files with an .rpn extension included with the program. More documentation might be available by the time you read this. 

### Keyboard shortcuts

* Ctrl-N: create new image
* Ctrl-O: open image file
* Ctrl-S: save image file
* Ctrl-L: focus the command line
* Ctrl-Q: quit program

(and at the Forth console)

* Ctrl-R: run code from the editor

## License and support

Tipsy Turtle is open source under the MIT License (and so is NiGui). See the included file for details.

I'd love to hear from you. Feel free to e-mail <nttp@ctrl-c.club>, or see the Tipsy Turtle homepage for other ways to contact me.
